
#include <i2cmaster.h>
#include <EEPROM.h>

char st1[30];
long int count = 0;
int mlr;
int mud;
int blr;
int bud;
char c = 0;

void setup(){ 
 Serial.begin(115200); //Выставление скорости для соединения
  mlr = EEPROM.read(0)*10; //Чтение существующих настроек из EEPROM датчика
  mud = EEPROM.read(1)*10;
  blr = EEPROM.read(2)*10;
  bud = EEPROM.read(3)*10;

 PORTC = (1 << PORTC4) | (1 << PORTC5); //Порты датчика MLX90614

}

void loop()
{ //основной цикл программы-непрерывное измерение температуры
  while(true){
   double tpl;
   tpl = readMLXtemperature(0); // читаем температуру с датчика
   tpl = tpl *10;
   tpl = tpl / 5;
   tpl=tpl-27315;
   Serial.println(tpl/100); // выводим сообщение в Serial monitor
   delay(200);
  }
}

long int readMLXtemperature(int TaTo) { // Функция для считывания данных с датчика по протоколу i2c
  long int lii;
  int dlsb,dmsb,pec;
  int dev = 0x5A<<1;
  i2c_init();
  i2c_start_wait(dev+I2C_WRITE);
  if (TaTo) i2c_write(0x06); else i2c_write(0x07);
  i2c_rep_start(dev+I2C_READ);
  dlsb = i2c_readAck();
  dmsb = i2c_readAck();
  pec = i2c_readNak();
  i2c_stop();
  lii=dmsb*0x100+dlsb;
  return(lii);
}
